package com.sun.corba.se.impl.naming.pcosnaming;

import java.io.ObjectOutputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.FileInputStream;
import org.omg.PortableServer.ForwardRequest;
import org.omg.PortableServer.Servant;
import org.omg.PortableServer.ServantLocatorPackage.CookieHolder;
import org.omg.PortableServer.POA;
import java.util.Hashtable;
import java.io.File;
import com.sun.corba.se.spi.orb.ORB;
import org.omg.PortableServer.ServantLocator;
import org.omg.CORBA.LocalObject;

public class ServantManagerImpl extends LocalObject implements ServantLocator
{
    private static final long serialVersionUID = 4028710359865748280L;
    private ORB orb;
    private NameService theNameService;
    private File logDir;
    private Hashtable contexts;
    private CounterDB counterDb;
    private int counter;
    private static final String objKeyPrefix = "NC";
    
    ServantManagerImpl(ORB orb, File logDir, NameService theNameService) {
        this.logDir = logDir;
        this.orb = orb;
        this.counterDb = new CounterDB(logDir);
        this.contexts = new Hashtable();
        this.theNameService = theNameService;
    }
    
    public Servant preinvoke(byte[] bytes, POA poa, String s, CookieHolder cookieHolder) throws ForwardRequest {
        String key = new String(bytes);
        Servant inContext = (Object)this.contexts.get(key);
        if (inContext == null) {
            inContext = this.readInContext(key);
            return inContext;
        }
        return inContext;
    }
    
    public void postinvoke(byte[] array, POA poa, String s, Object o, Servant servant) {
    }
    
    public NamingContextImpl readInContext(String key) {
        NamingContextImpl value = (NamingContextImpl)this.contexts.get(key);
        if (value != null) {
            return value;
        }
        File file = new File(this.logDir, key);
        if (file.exists()) {
            try {
                ObjectInputStream objectInputStream = new ObjectInputStream(new FileInputStream(file));
                value = (NamingContextImpl)objectInputStream.readObject();
                value.setORB(this.orb);
                value.setServantManagerImpl(this);
                value.setRootNameService(this.theNameService);
                objectInputStream.close();
            }
            catch (Exception ex) {}
        }
        if (value != null) {
            this.contexts.put(key, value);
            return value;
        }
        return value;
    }
    
    public NamingContextImpl addContext(String key, NamingContextImpl inContext) {
        File file = new File(this.logDir, key);
        if (file.exists()) {
            inContext = this.readInContext(key);
        }
        else {
            try {
                ObjectOutputStream objectOutputStream = new ObjectOutputStream(new FileOutputStream(file));
                objectOutputStream.writeObject(inContext);
                objectOutputStream.close();
            }
            catch (Exception ex) {}
        }
        try {
            this.contexts.remove(key);
        }
        catch (Exception ex2) {}
        this.contexts.put(key, inContext);
        return inContext;
    }
    
    public void updateContext(String s, NamingContextImpl obj) {
        File file = new File(this.logDir, s);
        if (file.exists()) {
            file.delete();
            file = new File(this.logDir, s);
        }
        try {
            ObjectOutputStream o = new ObjectOutputStream(new FileOutputStream(file));
            o.writeObject(obj);
            o.close();
        }
        catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    
    public static String getRootObjectKey() {
        return "NC0";
    }
    
    public String getNewObjectKey() {
        return "NC" + this.counterDb.getNextCounter();
    }
}
